/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

let gPrefBranch = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefBranch);

var bundle = srGetStrBundle("chrome://customcalendardefaults/locale/ccd-prefs.properties");

function ccdResetCalendarDefaults() {
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.status")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.status");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.priority")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.priority");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.showTimeAs")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.showTimeAs");
  }
  if (gPrefBranch.prefHasUserValue("calendar.events.defaultTransparency.standard.transparent")) {
    void gPrefBranch.clearUserPref("calendar.events.defaultTransparency.standard.transparent");
  }
  if (gPrefBranch.prefHasUserValue("calendar.events.defaultTransparency.allday.transparent")) {
    void gPrefBranch.clearUserPref("calendar.events.defaultTransparency.allday.transparent");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.status")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.status");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.priority")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.priority");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.showTimeAs")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.showTimeAs");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.showTimeAs.state")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.showTimeAs.state");
  }
  onLoadCcdPrefsPane();
}

function onLoadCcdPrefsPane() {
  var ccdEventPriority = document.getElementById("ccdEventPriority");
  var defaultEventPriority = gPrefBranch.getCharPref("extensions.customcalendardefaults.event.priority");
  var eventPriorityNone = bundle.GetStringFromName( "eventPriorityNone.label" );
  var eventPriorityLow = bundle.GetStringFromName( "eventPriorityLow.label" );
  var eventPriorityHigh = bundle.GetStringFromName( "eventPriorityHigh.label" );
  var eventPriorityNormal = bundle.GetStringFromName( "eventPriorityNormal.label" );
  if (defaultEventPriority == "0") {
    ccdEventPriority.setAttribute("label", eventPriorityNone);
  } else if (defaultEventPriority == "1") {
    ccdEventPriority.setAttribute("label", eventPriorityHigh);
  } else if (defaultEventPriority == "5") {
    ccdEventPriority.setAttribute("label", eventPriorityNormal);
  } else if (defaultEventPriority == "9") {
    ccdEventPriority.setAttribute("label", eventPriorityLow);
  }
  
  var ccdEventStatus = document.getElementById("ccdEventStatus");
  var defaultEventStatus = gPrefBranch.getCharPref("extensions.customcalendardefaults.event.status");
  var eventStatusNone = bundle.GetStringFromName( "eventStatusNone.label" );
  var eventStatusTentative = bundle.GetStringFromName( "eventStatusTentative.label" );
  var eventStatusConfirmed = bundle.GetStringFromName( "eventStatusConfirmed.label" );
  var eventStatusCancelled = bundle.GetStringFromName( "eventStatusCancelled.label" );
  if (defaultEventStatus == "") {
    ccdEventStatus.setAttribute("label", eventStatusNone);
  } else if (defaultEventStatus == "TENTATIVE") {
    ccdEventStatus.setAttribute("label", eventStatusTentative);
  } else if (defaultEventStatus == "CONFIRMED") {
    ccdEventStatus.setAttribute("label", eventStatusConfirmed);
  } else if (defaultEventStatus == "CANCELLED") {
    ccdEventStatus.setAttribute("label", eventStatusCancelled);
  }
  
  var ccdTaskPriority = document.getElementById("ccdTaskPriority");
  var defaultTaskPriority = gPrefBranch.getCharPref("extensions.customcalendardefaults.task.priority");
  var taskPriorityNone = bundle.GetStringFromName( "taskPriorityNone.label" );
  var taskPriorityLow = bundle.GetStringFromName( "taskPriorityLow.label" );
  var taskPriorityHigh = bundle.GetStringFromName( "taskPriorityHigh.label" );
  var taskPriorityNormal = bundle.GetStringFromName( "taskPriorityNormal.label" );
  if (defaultTaskPriority == "0") {
    ccdTaskPriority.setAttribute("label", taskPriorityNone);
  } else if (defaultTaskPriority == "1") {
    ccdTaskPriority.setAttribute("label", taskPriorityHigh);
  } else if (defaultTaskPriority == "5") {
    ccdTaskPriority.setAttribute("label", taskPriorityNormal);
  } else if (defaultTaskPriority == "9") {
    ccdTaskPriority.setAttribute("label", taskPriorityLow);
  }
  
  var ccdTaskStatus = document.getElementById("ccdTaskStatus");
  var defaultTaskStatus = gPrefBranch.getCharPref("extensions.customcalendardefaults.task.status");
  var taskStatusNone = bundle.GetStringFromName( "taskStatusNone.label" );
  var taskStatusAction = bundle.GetStringFromName( "taskStatusAction.label" );
  var taskStatusProcess = bundle.GetStringFromName( "taskStatusProcess.label" );
  var taskStatusCompleted = bundle.GetStringFromName( "taskStatusCompleted.label" );
  var taskStatusCancelled = bundle.GetStringFromName( "taskStatusCancelled.label" );
  if (defaultTaskStatus == "") {
    ccdTaskStatus.setAttribute("label", taskStatusNone);
  } else if (defaultTaskStatus == "NEEDS-ACTION") {
    ccdTaskStatus.setAttribute("label", taskStatusAction);
  } else if (defaultTaskStatus == "IN-PROCESS") {
    ccdTaskStatus.setAttribute("label", taskStatusProcess);
  } else if (defaultTaskStatus == "COMPLETED") {
    ccdTaskStatus.setAttribute("label", taskStatusCompleted);
  } else if (defaultTaskStatus == "CANCELLED") {
    ccdTaskStatus.setAttribute("label", taskStatusCancelled);
  }
}
